import numpy as np
import cv2
import tritonclient.http as httpclient
import time
import base64

if __name__ == '__main__':
    triton_client = httpclient.InferenceServerClient(url='127.0.0.1:8000')
    img_path = '/data_raid0/triton_workspace_plus/model_repository4_plus/triton_deploy/images/input_img/test_images/6.jpg'
    # img_path = '/images/input_img/67.jpg'
    with open(img_path,"rb") as f:
        # base64 encode
        base64_data = base64.b64encode(f.read())
        # str
        base64_data_str = base64_data.decode('utf8')
        # base64
        # base64_data = base64_data_str.encode('utf8')
        # base to opencv
        # with open("./tmp.jpg","wb") as f:
              # base64 decode
        #     img = base64.b64decode(base64_data)
        #     # f.write(img)
              # base64 to numpy
        #     np_data = np.frombuffer(img,np.uint8)
              # numpy [one,] to numpy [h,w,c]
        #     img_arr = cv2.imdecode(np_data,cv2.IMREAD_COLOR)
        # exit()

    img_path = base64_data_str
    # img_path = 'https://pic.rmb.bdstatic.com/bjh/down/e0b159fdbd9eba47bbfbdff212492bd4.jpeg'
    input_data0 = np.array([img_path.encode("utf-8")],dtype=np.object_)
    # print("input_data0:",input_data0)
    inputs = []
    inputs.append(httpclient.InferInput('input0', [1], "BYTES"))
    inputs[0].set_data_from_numpy(input_data0, binary_data=True)
    outputs = []
    outputs.append(httpclient.InferRequestedOutput('output0', binary_data=False))
    # outputs.append(httpclient.InferRequestedOutput('output1', binary_data=False))
    t1 = time.time()
    results = triton_client.infer('custom_model', inputs=inputs, outputs=outputs)
    t2 = time.time()
    print('inference time is: {:.1f}ms'.format(1000 * (t2 - t1)))
    output_data0 = results.as_numpy('output0')
    print("output_data0:",output_data0)
    # output_data1 = results.as_numpy('output1')
    # print("output_data1:",output_data1)



